<?php
$default_options = array(
	'maxwidth' => '0',
	'lockheight' => '1',
	'height' => '500',
	'maxheight' => '0',
 	'property0' => 'opaque',
	'property1' => 'ffffff',
	'property2' => '10',
	'thumbWidth' => '160',
	'thumbHeight' => '160',
	'property7' => '75c30f',
	'property8' => '232323',
	'property15' => '75c30f',
	'property16' => '000000',
	'linesColor' => '444444',
	'linkColor' => '75c30f',
	'titleLinkTarget' => 'auto',
	'titleLinkColor' => '75c30f',
	'titleFontSize' => '12',
	'descriptionFontSize' => '12',
	'backButtonColorBg' => '000000',
	'backButtonColorText' => 'ffffff',
	'hitCounter' => '1',
	'customCSS' => ''
);
$options_tree = array(
	array(
		'label' => 'Common Settings',
		'fields' => array(
			'maxwidth' => array(
				'label' => 'Max-Width',
				'tag' => 'input',
				'attr' => 'type="number" min="0"',
				'text' => 'Set the maximum width of the gallery. Leave 0 to disable max-width.'
			),
			'lockheight' => array(
				'label' => 'Set height manually',
				'tag' => 'checkbox',
				'attr' => 'data-watch="change"',
				'text' => 'By default a gallery automatically calculates own height to best fit the tallest image in a gallery.'
			),
			'height' => array(
				'label' => 'Height',
				'tag' => 'input',
				'attr' => 'type="text" min="0" data-lockheight="is:1"',
				'text' => 'Set height of the gallery. Do not set % unless you know what you doing.'
			),
			'maxheight' => array(
				'label' => 'Max-Height',
				'tag' => 'input',
				'attr' => 'type="number" min="0" data-lockheight="is:0"',
				'text' => 'Set the maximum height of the gallery. Leave 0 to disable max-height.'
			),
			'property2' => array(
				'label' => 'Slideshow Delay',
				'tag' => 'input',
				'attr' => 'type="number" min="1" max="60"',
				'text' => 'Set delay between slides in seconds'
			),
			'hitCounter' => array(
				'label' => 'Views Counter Switch',
				'tag' => 'checkbox',
				'attr' => '',
				'text' => 'Enable / Disable'
			),
			'property0' => array(
				'label' => 'Wmode for flash object',
				'tag' => 'select',
				'attr' => '',
				'text' => 'Default value: Opaque. If \'transparent\' - "Background Color" option is ignored, but you can position the absolute elements over the flash',
				'choices' => array(
					array(
						'label' => 'Opaque',
						'value' => 'opaque'
					),
					array(
						'label' => 'Window',
						'value' => 'window'
					),
					array(
						'label' => 'Transparent',
						'value' => 'transparent'
					)
				)
			),
			'property1' => array(
				'label' => 'Background Color',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color"',
				'text' => 'Set gallery background color. If Wmode is transparent, then this color will be used in fullscreenmode only.'
			),
			'linesColor' => array(
				'label' => 'Lines Color (Header & Footer)',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color"',
				'text' => ''
			),
			'thumbWidth' => array(
				'label' => 'Thumbnail Width',
				'tag' => 'input',
				'attr' => 'type="number" min="30" max="300"',
				'text' => ''
			),
			'thumbHeight' => array(
				'label' => 'Thumbnail Height',
				'tag' => 'input',
				'attr' => 'type="number" min="30" max="300"',
				'text' => ''
			),
			'property7' => array(
				'label' => 'Category Buttons Color',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color"',
				'text' => ''
			),
			'property8' => array(
				'label' => 'Category Buttons Color on Mouseover',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color" ',
				'text' => ''
			),
			'property15' => array(
				'label' => 'Image Title Color',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color"',
				'text' => 'Color of text for image title in the description.'
			),
			'titleLinkColor' => array(
				'label' => 'Image Title Link Color',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color"',
				'text' => 'Color of text for image title if it is link.'
			),
			'titleLinkTarget' => array(
				'label' => 'Title Link Target',
				'tag' => 'select',
				'attr' => '',
				'text' => 'Open link in same window or in new window when click on title. Set "auto" to open in new window only external links.',
				'choices' => array(
					array(
						'label' => 'auto',
						'value' => 'auto'
					),
					array(
						'label' => '_self',
						'value' => '_self'
					),
					array(
						'label' => '_blank',
						'value' => '_blank'
					)
				)

			),
			'titleFontSize' => array(
				'label' => 'Title Text Font Size',
				'tag' => 'input',
				'attr' => 'type="number" min="8" max="24"',
				'text' => ''
			),
			'property16' => array(
				'label' => 'Image Description Text Color',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color"',
				'text' => 'Color of text for image description.'
			),
			'descriptionFontSize' => array(
				'label' => 'Description Text Font Size',
				'tag' => 'input',
				'attr' => 'type="number" min="8" max="24"',
				'text' => ''
			),
			'linkColor' => array(
				'label' => 'Image Description Link Color',
				'tag' => 'input',
				'attr' => 'type="text" data-type="color"',
				'text' => 'Color of text for image description.'
			)
		)
	),
	array(
		'label' => 'Advanced Settings',
		'fields' => array(
			'customCSS' => array(
				'label' => 'Custom CSS',
				'tag' => 'textarea',
				'attr' => 'cols="20" rows="10"',
				'text' => 'You can enter custom style rules into this box if you\'d like. IE: <i>a{color: red !important;}</i><br />This is an advanced option! This is not recommended for users not fluent in CSS... but if you do know CSS, anything you add here will override the default styles'
			)
			/*,
			'loveLink' => array(
				'label' => 'Display LoveLink?',
				'tag' => 'checkbox',
				'attr' => '',
				'text' => 'Selecting "Yes" will show the lovelink icon (codeasily.com) somewhere on the gallery'
			)*/
		)
	)
);
